func_var_multi<-function(x)
{
  # fx=x[1]^4+x[1]^3-x[1]+x[2]^4-x[2]^2 +x[2]+x[3]^2-x[3]+x[1]*x[2]*x[3]
  # fx=0.5*x[1]^2+x[2]^2+x[1]+0.5*x[2]+3
 # fx=garch11_likelihood(x,data)
  fx=x[1]^2+x[2]^2+x[3]^2
  return(fx)
}

# compute the gradient numerically

grad_vec<-function(x)
{ delx=0.0001
grad_vec=c()
for(i in 1:length(x))
{ x_old=x
x_new=x
x_old=x
x_old[i]=x[i]-delx
x_new[i]=x[i]+delx
grad_vec[i]=(func_var_multi(x_new)-func_var_multi(x_old))/(2*delx)
}
return(grad_vec)  
}

# alternatively you may pass a function as an input in a function

grad_vec_1<-function(f,x)
{ delx=0.0001
grad_vec=c()
for(i in 1:length(x))
{ x_old=x
x_new=x
x_old=x
x_old[i]=x[i]-delx
x_new[i]=x[i]+delx
grad_vec[i]=(f(x_new)-f(x_old))/(2*delx)
}
return(grad_vec)  
}




#########################################
#
#  Steepest descent
#

steepest_descent_standard<-function(x,epsilon,alpha,max_iter)
{
  f_old=func_var_multi(x)
  n_iter=0   # counter for iteration time
  for(k in 0:max_iter)
  {
    n_iter=n_iter+1
    grad<-grad_vec(x)
    s_dir<- -grad   # compute the gradient and set search direction -Df
    
    # compute the step length using the golden search rule
    
    
    
    x=x+alpha*s_dir
    f_new=func_var_multi(x)
    
    # if f_old and f_new are close  or
    # the gradient is close to 0 we terminate the algorithm
    
    if(abs(f_new-f_old)<epsilon | norm(grad,"2")<epsilon)
      # if(norm(grad,"2")<epsilon)
    {break}
    norm_grad=norm(grad,"2")
    f_old<-f_new
    x=x+alpha*s_dir
  }
  grad<-grad_vec(x)
  norm_grad=norm(grad,"2")
  #cat( k, '\t',format(x,digits=4, nsmall =4),'\t', format(f_old ,digits=4, nsmall =4),'\t', format(norm_grad ,
                                                                                                   #digits=4, nsmall =4),'\n')
  
  xm=x
  gradm=grad_vec(xm)
  norm_gradm=norm(gradm,"2")
  results=list(xm,norm_gradm,n_iter)
  return(results)
}



x_init=cbind(1,1,1)    # set the initial value for the iteration to start
epsilon=0.00000000000000000000001
alpha=0.1
max_iter=100

results=steepest_descent_standard(x_init,epsilon,alpha,max_iter)
results


# alternatively you may pass a function as an argument

steepest_descent_standard_1<-function(f,x,epsilon,alpha,max_iter)
{
  f_old=f(x)
  n_iter=0   # counter for iteration time
  for(k in 0:max_iter)
  {
    n_iter=n_iter+1
    grad<-grad_vec_1(x)
    s_dir<- -grad   # compute the gradient and set search direction -Df
    
    # compute the step length using the golden search rule
    
    
    
    x=x+alpha*s_dir
    f_new=f(x)
    
    # if f_old and f_new are close  or
    # the gradient is close to 0 we terminate the algorithm
    
    if(abs(f_new-f_old)<epsilon | norm(grad,"2")<epsilon)
      # if(norm(grad,"2")<epsilon)
    {break}
    norm_grad=norm(grad,"2")
    f_old<-f_new
    x=x+alpha*s_dir
  }
  grad<-grad_vec_1(x)
  norm_grad=norm(grad,"2")
 # cat( k, '\t',format(x,digits=4, nsmall =4),'\t', format(f_old ,digits=4, nsmall =4),'\t', format(norm_grad ,
                                                                                                   digits=4, nsmall =4),'\n')
  
  xm=x
  gradm=grad_vec_1(xm)
  norm_gradm=norm(gradm,"2")
  results=list(xm,norm_gradm,n_iter)
  return(results)
}


x_init=cbind(1.,1,1)    # set the initial value for the iteration to start
epsilon=0.0000000001
alpha=0.01
max_iter=100

results=steepest_descent_standard_1(f_var_multi,x_init,epsilon,alpha,max_iter)
results