
# generate mock data by simulation

n_features=6
n_data=10000
noise_size=0.1
set.seed(11)
x<-matrix(rnorm(n_data*n_features),ncol=n_features)
#y<-rnorm(n_data)
X<-cbind(rep(1,n_data),x)  # the column 1 is added for the bias
theta_true=sample.int(10,n_features+1)  # generate the true model
y=X%*%theta_true +noise_size*rnorm(n_data)   # generate the responses
theta_in<-rep(0,n_features+1)   # initialize theta

#  the loss function to be minimized

Loss<-function(X,y,theta){
  N=length(y)   # this should be equal to the number of data
 # L=sum((X%*%theta-y)^2)/(2*N)
  L=sum((X%*%theta-y)^2)/(2)
  return(L)
}

# loss function per da


#  gradient descent

gradient_descent<-function(X,y,theta,alpha,max_iter){
  N=length(y)
  L_history<-rep(0,max_iter)
  for(i in 1:max_iter){
    theta<-theta-alpha*(1/N)*(t(X)%*%(X%*%theta-y))  # here we calculate
                                              # the gradient explicitly
    #theta<-theta-alpha*(t(X)%*%(X%*%theta-y))
    L_history[i]<-Loss(X,y,theta)
  }
  results<-list(theta,L_history)
  return(results)
}


N=length(y)

stochastic_gradient_descent<-function(X,y,thetaa,alpha,N){  #max_iter=N
  #N=length(y)
  theta_sg<-thetaa  # initialize
  L_history_sg<-rep(0,N)   # this is number of iterations
  for(i in 1:N){
#    factor=X[i,]%*%thetaa-y[i]  # should be theta_sg but theta works better
#    factor=-y[i]
    factor=X[i,]%*%theta_sg-y[i]
    direction=X[i,]
    theta_sg<-theta_sg-alpha*(1/N)*as.vector(factor)*direction  # here we calculate
    # the gradient explicitly but only for the i-th datum
    L_history_sg[i]<-Loss(X,y,theta_sg)
  }
  results<-list(theta_sg,L_history_sg)
  return(results)
}


#  now execute 

alpha<-1
alpha_sg<-10
max_iter<-100
results<-gradient_descent(X,y,theta_in,alpha,max_iter)
theta<-results[[1]]   # retrieve theta vector
L_history<-results[[2]]  # retrieve L_history
results_sg<-stochastic_gradient_descent(X,y,theta_in,alpha_sg,N)
theta_sg<-results_sg[[1]]   # retrieve theta vector
L_history_sg<-results_sg[[2]]  # retrieve L_history

# compare theta with theta_true

theta_true

theta

theta_sg

# plot Loss function as a function of the iteration number

plot(L_history)

plot(L_history_sg)
